TagLib::ID3v2::UserUrlLinkFrame Class Reference

ID3v2 User defined URL frame. More...

`#include <urllinkframe.h>`

Inheritance diagram for TagLib::ID3v2::UserUrlLinkFrame:
[legend]
Collaboration diagram for TagLib::ID3v2::UserUrlLinkFrame:
[legend]

## Public Member Functions

| UserUrlLinkFrame (String::Type encoding=String::Latin1)
| UserUrlLinkFrame (const ByteVector &data)
| ~UserUrlLinkFrame () override
| UserUrlLinkFrame (const UserUrlLinkFrame &)=delete
UserUrlLinkFrame & | operator= (const UserUrlLinkFrame &)=delete
String | toString () const override
String::Type | textEncoding () const
void | setTextEncoding (String::Type encoding)
String | description () const
void | setDescription (const String &s)
PropertyMap | asProperties () const override
Public Member Functions inherited from TagLib::ID3v2::UrlLinkFrame
| UrlLinkFrame (const ByteVector &data)
| ~UrlLinkFrame () override
| UrlLinkFrame (const UrlLinkFrame &)=delete
UrlLinkFrame & | operator= (const UrlLinkFrame &)=delete
virtual String | url () const
virtual void | setUrl (const String &s)
void | setText (const String &s) override
Public Member Functions inherited from TagLib::ID3v2::Frame
virtual | ~Frame ()
| Frame (const Frame &)=delete
Frame & | operator= (const Frame &)=delete
ByteVector | frameID () const
unsigned int | size () const
unsigned int | headerSize () const
void | setData (const ByteVector &data)
virtual StringList | toStringList () const
ByteVector | render () const
Header * | header () const

## Static Public Member Functions

static UserUrlLinkFrame * | find (const Tag *tag, const String &description)
Static Public Member Functions inherited from TagLib::ID3v2::Frame
static ByteVector | textDelimiter (String::Type t)
static ByteVector | keyToFrameID (const String &)
static String | frameIDToKey (const ByteVector &)

## Protected Member Functions

void | parseFields (const ByteVector &data) override
ByteVector | renderFields () const override
| UserUrlLinkFrame (const ByteVector &data, Header *h)
Protected Member Functions inherited from TagLib::ID3v2::UrlLinkFrame
| UrlLinkFrame (const ByteVector &data, Header *h)
Protected Member Functions inherited from TagLib::ID3v2::Frame
| Frame (const ByteVector &data)
| Frame (Header *h)
void | setHeader (Header *h, bool deleteCurrent=true)
void | parse (const ByteVector &data)
ByteVector | fieldData (const ByteVector &frameData) const
String | readStringField (const ByteVector &data, String::Type encoding, int *position=nullptr)
String::Type | checkTextEncoding (const StringList &fields, String::Type encoding) const

## Friends

class | FrameFactory

## Additional Inherited Members

Static Public Attributes inherited from TagLib::ID3v2::Frame
static const String | instrumentPrefix
static const String | commentPrefix
static const String | lyricsPrefix
static const String | urlPrefix
Static Protected Member Functions inherited from TagLib::ID3v2::Frame
static void | splitProperties (const PropertyMap &original, PropertyMap &singleFrameProperties, PropertyMap &tiplProperties, PropertyMap &tmclProperties)

## Detailed Description

ID3v2 User defined URL frame.

This is a specialization of URL link frames that allows for user defined entries. Each entry has a description in addition to the normal list of fields that a URL link frame has.

This description identifies the frame and must be unique.

## Constructor & Destructor Documentation

## UserUrlLinkFrame() [1/4]

TagLib::ID3v2::UserUrlLinkFrame::UserUrlLinkFrame | ( | String::Type | encoding = String::Latin1 | ) |

explicit

Constructs an empty user defined URL link frame. For this to be a useful frame both a description and text must be set.

References TagLib::String::Latin1.

Referenced by find(), operator=(), and UserUrlLinkFrame().

## UserUrlLinkFrame() [2/4]

TagLib::ID3v2::UserUrlLinkFrame::UserUrlLinkFrame | ( | const ByteVector & | data | ) |

explicit

This is a dual purpose constructor. data can either be binary data that should be parsed or (at a minimum) the frame ID.

## ~UserUrlLinkFrame()

TagLib::ID3v2::UserUrlLinkFrame::~UserUrlLinkFrame | ( |  | ) |

override

Destroys this UserUrlLinkFrame instance.

## UserUrlLinkFrame() [3/4]

TagLib::ID3v2::UserUrlLinkFrame::UserUrlLinkFrame | ( | const UserUrlLinkFrame & |  | ) |

delete

References UserUrlLinkFrame().

## UserUrlLinkFrame() [4/4]

TagLib::ID3v2::UserUrlLinkFrame::UserUrlLinkFrame | ( | const ByteVector & | data,
|  | Header * | h )

protected

The constructor used by the FrameFactory.

References TAGLIB_MSVC_SUPPRESS_WARNING_NEEDS_TO_HAVE_DLL_INTERFACE.

## Member Function Documentation

## asProperties()

PropertyMap TagLib::ID3v2::UserUrlLinkFrame::asProperties | ( |  | ) | const

override virtual

Parses the UserUrlLinkFrame as PropertyMap. The description() is taken as key, and the URL as a single value.

- if description() is empty, the key will be "URL".
- otherwise, if description() is not a valid key (e.g. containing non-ASCII characters), the returned map will contain an entry "WXXX/<description>" in its unsupportedData() list.

Reimplemented from TagLib::ID3v2::UrlLinkFrame.

## description()

String TagLib::ID3v2::UserUrlLinkFrame::description | ( |  | ) | const

Returns the description for this frame.

Referenced by find().

## find()

UserUrlLinkFrame * TagLib::ID3v2::UserUrlLinkFrame::find | ( | const Tag * | tag,
|  | const String & | description )

static

Searches for the user defined url frame with the description description in tag. This returns null if no matching frames were found.

References description(), and UserUrlLinkFrame().

## operator=()

UserUrlLinkFrame & TagLib::ID3v2::UserUrlLinkFrame::operator= | ( | const UserUrlLinkFrame & |  | ) |

delete

References UserUrlLinkFrame().

## parseFields()

void TagLib::ID3v2::UserUrlLinkFrame::parseFields | ( | const ByteVector & | data | ) |

override protected virtual

Called by parse() to parse the field data. It makes this information available through the public API. This must be overridden by the subclasses.

Reimplemented from TagLib::ID3v2::UrlLinkFrame.

## renderFields()

ByteVector TagLib::ID3v2::UserUrlLinkFrame::renderFields | ( |  | ) | const

override protected virtual

Render the field data back to a binary format in a ByteVector. This must be overridden by subclasses.

Reimplemented from TagLib::ID3v2::UrlLinkFrame.

## setDescription()

void TagLib::ID3v2::UserUrlLinkFrame::setDescription | ( | const String & | s | ) |

Sets the description of the frame to s. s must be unique.

## setTextEncoding()

void TagLib::ID3v2::UserUrlLinkFrame::setTextEncoding | ( | String::Type | encoding | ) |

Sets the text encoding to be used when rendering this frame to encoding.

See also
  textEncoding()
  render()

## textEncoding()

String::Type TagLib::ID3v2::UserUrlLinkFrame::textEncoding | ( |  | ) | const

Returns the text encoding that will be used in rendering this frame. This defaults to the type that was either specified in the constructor or read from the frame when parsed.

See also
  setTextEncoding()
  render()

## toString()

String TagLib::ID3v2::UserUrlLinkFrame::toString | ( |  | ) | const

override virtual

This returns the textual representation of the data in the frame. Subclasses must reimplement this method to provide a string representation of the frame's data.

Reimplemented from TagLib::ID3v2::UrlLinkFrame.

## Friends And Related Symbol Documentation

## FrameFactory

friend class FrameFactory

friend

References FrameFactory.

Referenced by FrameFactory.

The documentation for this class was generated from the following file:

- urllinkframe.h